//: C01:Nonlocal2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Ukazuje výjimky.
#include <iostream>
using namespace std;

class Duha {
public:
  Duha() { cout << "Duha()" << endl; }
  ~Duha() { cout << "~Duha()" << endl; }
};

void oz() {
  Duha du;
  for(int i = 0; i < 3; i++)
    cout << "Všude dobře, doma nejlépe" << endl;
  throw 47;
}

int main() {
  try {
    cout << "tornádo, čarodějnice, pidimužíci..." << endl;
    oz();
  } catch(int) {
    cout << "Tetičko Em! Zdál se mi ten nejdivnější sen..."
         << endl;
  }
} ///:~
